//$.holdReady(true);
(function(w){
	/**
	 * 工具封装
	 * @author chijunchao<hs_80@qq.com> 9020
	 * 对APP的基础工具进行封装，使用方法：Tools.方法(参数);
	 */
	var orderCountLoading = openwindowing = false;	//标记是否正在打开窗口
	w.Tools = {
		//显示系统等待框的句柄
		hasWaiting : false,
		//返回前操作句柄
		preBackHd : [],
		//默认的状态栏颜色
		statusBar : 'dark',
		//首页按两次返回退出的标识
		waitingBack : false,
		//返回操作句柄,
		backHd : function(){
			var self = this, current = self.getCurrentWindow();
			//判断是否首页
			if(current.id == self.getIndexWindow().id){
				if(self.waitingBack){
					plus.runtime.quit();
					return false;
				}else{
					self.waitingBack = true;
					self.toast('再按一次退出亿品赞');
					setTimeout(function(){
						self.waitingBack = false;
					}, 2000);
					return false;
				}
			}else{
				current.canBack(function(event){
					if(event.canBack){
						current.back();
					}else{
						current.close();
					}
				});
				return false;
			}
			
		},
		//框架加载成功
		ready : function(fun){
			//安卓和ios均已实现plus直接调用
			//document.addEventListener("plusready",function(){  },false);
			
			$(function(){fun(Tools);});
		},
		
		/**
		 * 执行返回前的操作
		 * @param {Function} fun
		 * @param {int} type 	1:替换掉所有之前的设置
		 */
		preBack : function(fun, type){
			if(type || type == 1) this.preBackHd = [];
			if($.isFunction(fun)){
				this.preBackHd[this.preBackHd.length] = fun;
			}
		},
		
		/**
		 * 设置返回的操作
		 */
		back : function(fun){
			if($.isFunction(fun)){
				this.backHd = fun;
			}
		},
		
		/**
		 * 执行的返回方法
		 */
		doBack : function(){
			//开始执行返回前操作
			if(Tools.preBackHd && Tools.preBackHd.length > 0){
				for(var i in Tools.preBackHd){
					Tools.preBackHd[i]();
				}
			}
			return Tools.backHd();
			/*var backs	= Tools.backHd();
			if(typeof backs == 'boolean' && !backs){
				return false;
			}
			
			//开始返回逻辑
			var current	= Tools.getCurrentWindow();
			if(current.canBack()){
				current.back();
			}else{
				current.close('auto');
			}
			return false;*/
		},
		
		/**
		 * 打开新窗口
		 * @param {String} url	需要打开的URL
		 * @param {Object} data	传递的页面参数
		 * @param {integer}style 页面动画样式，0：无动画， 1：左打开，2：右打开
		 * @param {String} id	页面ID，不传此值则使用url代替
		 */
		openWindow : function (url, data, titleStyle, waiting, showStyle, id, statusbar, login, callback, render, popGesture, winstyle){
			data		= data || {};
			titleStyle	= titleStyle || null;
			waiting		= typeof waiting != 'undefined' ? waiting : true;
			id = id || url;
			showStyle	= typeof showStyle == 'undefined' ? 1 : showStyle;
			login		= login || false;
			callback	= callback || function(){};
			render	= render ? true : false
//			if(openwindowing) {
//				setTimeout(function(){
//					openwindowing = false;
//				}, 2500);
//				return null;
//			};
//			openwindowing = true;
			
			//窗口打开方式
			var anishow = [
					'none', 			//0:无动画效果
					'slide-in-right', 	//1:从右侧横向滑动效果
					'slide-in-left', 	//2:从左侧横向滑动效果
					'slide-in-top', 	//3:从上侧竖向滑动效果
					'slide-in-bottom', 	//4:从下侧竖向滑动效果
					'fade-in', 			//5:从透明到不透明逐渐显示效果
					'zoom-out', 		//6:从小到大逐渐放大显示效果
					'zoom-fade-out', 	//7:从小到大逐渐放大并且从透明到不透明逐渐显示效果
					'pop-in', 			//8:从右侧平移入栈动画效果
					'auto'				//9:自动选择动画效果，使用上次显示窗口设置的动画效果，如果是第一次显示则默认动画效果“none”。
			];
			
	//		showStyle	= anishow[showStyle] || "slide-in-right";
			
			var styles = {
				acceleration:'capture',
				backButtonAutoControl : "close",
				background : "#FFFFFF",
				blockNetworkImage : false,
				decelerationRate : 0.9,
				kernel : "WKWebview",
				mask : "none",	//rgba(0,0,0,0.5)
				opacity : 1,
				popGesture : popGesture || "close",
				scalable : false,
				scrollIndicator : "none",
				scrollsToTop : false,
				render : render ? "always" : "onscreen",
				titleNView : titleStyle
			}, webview = null, nWaiting;
			
			if(!url) {
				throw new Error('Need URL');
			}
			
			if(statusbar){
				styles.statusbar = statusbar;
			}
			
			webview = plus.webview.getWebviewById(id);
			if(webview) { //已缓存
				if(showStyle != null) webview.show(anishow[showStyle], 400);
				webview.type = 1;
				try{callback(webview, 1);}catch(e){}
				openwindowing = false;
				return webview;
			}
			
			//判断是否已登录，如果没登陆则跳转登陆，然后再回来处理窗口打开
			if(login && !this.checkLogin()){
				openwindowing = false;
				Tools.login(function(){
					Tools.openWindow(url, data, titleStyle, waiting, showStyle, id, statusbar, login, callback, render);
				});
				return false;
			}
			
			if(winstyle){
				for(var mmm in winstyle){
					styles[mmm] = winstyle[mmm];
				}
			}
			
			webview = plus.webview.create( url, id || url, styles, data );
			
			/*if(waiting){
				nWaiting = this.waiting();
			}*/
			
			
			webview.addEventListener("loading", function() {
				//显示页面
				if(showStyle != null) {
					webview.show(anishow[showStyle] || "slide-in-right", 400, function(){
						try{callback(webview, 0);}catch(e){}
					});
				}else{
					try{callback(webview, 0);}catch(e){}
				}
				
				openwindowing = false;
			}, false);
			
			/*webview.addEventListener("rendered", function() {
				Tools.setTopWindowStatusBar();
				//显示页面
				webview.show(anishow[showStyle] || "slide-in-right", 400, function(){
					Tools.setTopWindowStatusBar();
				});
				webview.type = 0;
				try{callback(webview, 0);}catch(e){}
				
				openwindowing = false;
				
				Tools.setTopWindowStatusBar();
				
				//关闭等待框
				if(nWaiting) {
					nWaiting.close();
					nWaiting = null;
				}
			});*/
			
			webview.type = 0;
			webview.showNow = function(){
				webview.show(anishow[showStyle] || "slide-in-right", 400);
				openwindowing = false;
			}
			return webview;
		},
		
		/**
		 * 打开普通带导航条的窗口
		 * type 可选值 default、transparent
		 */
		openWindowWithNav : function(url, data, title, type, buttons, login, showStyle, id, callback, render){ 
			var titleStyle	= this.window.title(title || '', type, "#FFFFFF", true, buttons);
//			var statusbar = /*type == 'transparent' ? {background:'#000000'} : */{background: "#FFFFFF"};
			return this.openWindow(url, data, titleStyle, true, showStyle, id,null, login || false, callback, render);
		},

		/**
		 * 根据窗口ID获取窗口对象
		 */
		getWindowById : function(id){
			return plus.webview.getWebviewById(id);
		},

		/**
		 * 设置状态栏
		 * @param {String} style	dark:黑色文字， light：浅色文字
		 */
		setStatusBar : function(style){
			style	= style || this.statusBar;
			plus.navigator.setStatusBarStyle(style);
			if(!plus.navigator.isImmersedStatusbar()){
				if(style == 'dark'){
					plus.navigator.setStatusBarBackground('#FFFFFF');
				}else{
					plus.navigator.setStatusBarBackground('#E60024');
				}
			}
			
			var wv = this.getCurrentWindow();
			if(['user.html', 'order.html'].indexOf(wv.id) >= 0 ){
				loadInfo();
			}
			this.broadcast('upbottomcount');
		},
		
		/**
		 * 类似浏览器方式有进度条打开窗口
		 */
		openWeb : function(url, title, showStyle){
			var self = this, webview = null, web_id = $.trim(url);
			title = title || "";
			
			if(!url) return ;

			//查找有没有打开过H5页面，如果打开过则销毁之前的页面
			if(self.getWindowById(web_id)){
                self.getWindowById(web_id).close('none');
                setTimeout(function () {
                    self.openWeb(url, title, showStyle);
                }, 500);
                return null;
            }
			
			var titleStyle	= this.window.title(title, "default", "#FFFFFF", false, [this.window.button('back', function(){
				webview.canBack(function(event){
					if(event.canBack){
						webview.back();
					}else{
						webview.close();
					}
				});
			},{
				text : '\ue61e',
				position : 'left'
			})], {height : "2px"});
			webview	= self.openWindow($.trim(url), {}, titleStyle, false, showStyle, web_id);
			//缓存页面则打开后重新加载url
			if(webview && webview.type == 1){
				webview.loadURL($.trim(url));
			}
			
			webview.addEventListener("titleUpdate", function(data) {
				webview.setStyle({titleNView:{titleText : data.title}}); 
			}, false);
			
			webview.addEventListener('close',function(){
				Tools.getIndexWindow().evalJS('Tools.setTopWindowStatusBar();');
			},false);
			
			Tools.setStatusBar('dark');
			return webview;
		},
		
		/**
		 * 打开二维码扫描页面
		 */
		openQrcode : function(){
			var qrcode ;
			qrcode = this.openWindowWithNav(
				'scan_qr_code.html', 
				{}, '扫描二维码', 'transparent', 
				[
					//手电筒
					this.window.button(null, function(){
						qrcode.evalJS('setFlash();');
					}, {text : '\ue68d'}),
					
					//相册
					this.window.button(null, function(){
						qrcode.evalJS('scanPicture();');
					}, {text : '\ue66e'})
				]
			);
		},
		
		/**
		 * 获取当前窗口的webview对象
		 */
		getCurrentWindow : function(){
			return this.getWindowById( plus.webview.currentWebview().id );
		},
		
		/**
		 * 获取首页窗口的webview对象
		 */
		getIndexWindow : function(){
			return plus.webview.getLaunchWebview();
		},
		
		/**
		 * 窗口属性设置方法
		 */
		window : {
			title : function(title, type, backColor, autoBack, buttons, progress, splitLine){
				autoBack	= typeof autoBack == 'undefined' ? true : autoBack;
				type	 	= type || "default";
				buttons		= buttons || null;
				progress	= progress || null;
				backColor	= backColor || "#FFFFFF";
				splitLine	= splitLine || {color : "#E5E5E5",height : "1px"}
				
				return titleNView = {
					autoBackButton : autoBack,
					backgroundColor : backColor,
					buttons : buttons,
					coverage : "132px",
					progress: progress,
					splitLine : splitLine,
					titleColor : "#000000",
					titleOverflow : "ellipsis",
					titleText : title,
					titleSize : "18px",
					type : type
				};
			},
			/**
			 * 获取标题按钮配置
			 * @param {String} type			//按钮的类型
			 * @param {Function} callback 	//回调函数
			 * @param {Object} position		//显示位置，left | right
			 */
			button : function(type, callback, conf){
				var option = {
					font : "_www/fonts/iconfont.ttf",
					fontSize : '20px',
					text : '',
					position : null,
					color : "#000000"
				};
				if(conf){
					for(var i in conf){
						option[i]	= conf[i];
					}
				}
				
				switch(type){
					case "home":	//主页按钮
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								plus.webview.getLaunchWebview().show("none");
							},
							text : "\ue626" 
						};
						break;
					case "more":	//更多按钮
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
							},
							text : "\ue61d"
						};
						break;
					case "share":	//分享按钮
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								//展示分享菜单项目
							},
							text : "\ue63f"
						};
						break;
					case "msg":		//消息中心按钮
						return {
							float : option.position || "left",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								//跳转消息中心逻辑
							},
							text : "\ue60d"
						};
						break;
					case "user":	//用户中心
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								//跳转用户中心
							},
							text : "\ue641"
						};
						break;
					case "search":	//搜索
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								//跳转搜索
							},
							text : "\ue630"
						};
						break;
					case "setting":	//设置
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								//跳转搜索
							},
							text : "\ue653"
						};
						break;
					default:
						return {
							float : option.position || "right",
							fontSize : option.fontSize,
							fontSrc : option.font,
							color : option.color,
							onclick : callback || function(){
								//跳转搜索
							},
							text : option.text
						};
						break;
				}
			},
		},
		
		/**
		 * 分享方法
		 * @param {String} title
		 * @param {String} content
		 * @param {String} url
		 * @param {Array} images
		 * @param {Function} callback
		 * @param {String} hide
		 * @param {int} type:分享类型不传则表示一键分享，传递需要传递平台类型：
		 * 					平台类型：QQ:10  Q空间:11   微信好友:12  微信朋友圈：13  新浪微博：14  腾讯微博：15  短信：16
		 */
		share : function(title, content, url, images, callback, hide, type){
			callback	= callback || function(){};
			hide	= typeof hide == 'undefined' ? 'tencent,weibo' : hide;
			
			plus.ypzan.share(title, content, url, images, callback, hide, type);
		},
		
		/**
		 * 打开一个原生的actionsheet选择菜单
		 */
		actionSheet : function(title, buttons, callback){
			title	= title || "";
			callback= callback || function(){};
			var btn	= [];
			if(!$.isArray(buttons)){
				btn[0]	= buttons;
			}else{
				for(var i in buttons){
					buttons[i].title	= buttons[i].title || "";
					buttons[i].style	= buttons[i].style != "default" ? "default" : "destructive" ;
					btn[i]	= {
						title : buttons[i].title,
						color : buttons[i].style == "default" ? "#333333" : "#FF0000",
						style : buttons[i].style
					};
				}
			}
			
			var option = {cancel:"取消",buttons:btn};
			title && (option.title = title);
			
			return plus.nativeUI.actionSheet(option, callback);
		},
		
		/**
		 * 打开一个提示框方式的原因选择菜单
		 */
		selectBox : function(title, items, callback){
			title	= title || "";
			items	= items || [];
			callback= callback || function(){};
			
			var buttons	= [];
			for(var i in items){
				buttons[i]	= {
					title : items[i],
					color : "#333333",
					style : "default"
				};
			}
			
			var option = {cancel:"取消",buttons:buttons};
			title && (option.title = title);
			
			return plus.nativeUI.actionSheet(option, callback);
		},
		
		/**
		 * 显示一个自动消失的提示框
		 */
		toast : function(msg){
			plus.nativeUI.toast( msg );
		},
		
		/**
		 * 打开一个警告框
		 */
		alert : function(msg, button, title, callback){
			button	= button || '确认';
			if(Tools.os.android){
				plus.ypzan.alert(title, msg, button, function(index){
					callback({index:index});
				});
			}else{
				plus.nativeUI.alert( msg, callback, title, button );
			}
		},
		
		/**
		 * 打开一个确认框
		 */
		confirm : function(msg, callback, buttons, title){
			buttons	= buttons || ['确认', '取消'];
			
			if(Tools.os.android){
				plus.ypzan.confirm(title, msg, buttons, function(index){
					callback({index:index});
				});
			}else{
				var options	= {};
				if(title) options.title = title;
				options.buttons	= buttons;
				plus.nativeUI.confirm(msg, callback, options);
			}
		},
		
		
		/**
		 * 显示等待提示
		 */
		waiting : function(str){
			if(this.hasWaiting) return this.hasWaiting;
			plus.nativeUI.closeWaiting();
			str	= str || '正在加载...';
			this.hasWaiting = plus.nativeUI.showWaiting( str, {});
			var self = this;
			//绑定关闭事件
			this.hasWaiting.onclose = function(){
				self.hasWaiting = false;
			}
			return  this.hasWaiting;
		},

		/**
		 * 打开在线客服窗口
		 */
		online : function(){
			this.openWeb('https://gxdbwlkjyxgs.qiyukf.com/client?k=d4b9053d22f9892cced9b15b1c42871d&wp=1&robotShuntSwitch=1&robotId=1557586');
		},

		/**
		 * 关闭等待提示
		 */
		closeWaiting : function(){
			plus.nativeUI.closeWaiting();
		},
		
		//提示方式显示错误信息
		error : function(msg, callback, pos){
			msg	= msg || '提交失败';
			pos	= pos || 'center';
			this.notice(msg, callback, pos, {icon : "\ue646"});
		},
		
		/**
		 * 成功提示
		 */
		success : function(msg, callback, pos){
			msg	= msg || '提交成功';
			pos	= pos || 'center';
			this.notice(msg, callback, pos, {icon : "\ue639"});
		},
		
		
		/**
		 * 提示信息
		 * @param {String} msg	信息内容
		 * @param {String} pos	提示位置：center：屏幕中间（默认）, top : 居上， bottom:居下
		 */
		notice : function(msg, callback, pos, options){
			options	= options || {};
			
			/*if(Tools.os.android){
				var option = {
					pos : pos || 'center',
					icon : options.icon || '',
					iconSize : options.iconSize || 30,
					fontSize : options.fontSize || 16,
					autoHide : options.autoHide || 2000,
				}
				plus.ypzan.notice(msg, callback, option)
				return ;
			}*/
			
			var box = $('<div>').css({
				position:'fixed',
				background:'rgba(0,0,0,0.8)', 
				color:'#FFF',
				top:100,
				padding:15,
				borderRadius:8,
				display:'none',
				zIndex:99999,
//				whiteSpace:"nowrap",
			}).html(msg), _css={};
			
			callback	= callback || function(){};
			
			switch(pos){
				case 'top':
					_css = {top:30};
					break;
				case 'bottom':
					_css = {bottom:30,top:'auto'};
					break;
				case 'center':
				default:
					_css = {top:0,bottom:0};
					break;
			}
			options	= options || {};
			if(typeof options.autoHide == 'undefined'){
				options.autoHide	= 2000;
			}
			
			//存在图标配置则处理图标
			if(options.icon){
				$('<p>').addClass('ypzan').html(options.icon).css({textAlign:'center',margin:'15px 0 5px',color:"#FFF",fontSize:30,height:30}).prependTo(box);;
			}
			if(options.img){
				$('<p>').html('<img src="'+options.img+'" width="50" height="50" />').css({textAlign:'center',marginBottom:10}).prependTo(box);
			}
			
			box.appendTo('body').fadeIn(200);
			if(box.outerWidth() > (screen.width - screen.width * 0.2)){	//屏幕宽度的80%
				box.css({width: (screen.width - screen.width * 0.2)});
			}else{
				box.css({width: box.outerWidth() + 10});
			}
			
			box.css({height:box.outerHeight(),left:0,right:0,margin:'auto'}).css(_css);
			
			if(options.autoHide){
				setTimeout(function(){
					box.fadeOut(200, function(){box.remove();});
					callback();
				}, options.autoHide);
			}else{
				callback();
			}
			
			return box;
		},
		
		/**
		 * 获取新窗口打开时传递的值
		 * @param {String} name	获取的参数名
		 * ----------------------------------
		 * @return {String} 
		 */
		getExt : function(name){
			var ws = plus.webview.currentWebview();
			return ws[name] || '';
		},
		
		
		/**
		 * 格式化字节大小
		 * @param  number $size      字节数
		 * @param  string $delimiter 数字和单位分隔符
		 */
		formatBytes : function (size, type) {
			type  = type || false;
		    units = ['B', 'KB', 'MB', 'GB', 'TB', 'PB'];
		    for (var i = 0; size >= 1024 && i < 5; i++) size /= 1024;
		    
		    if(type && i <= 1){
		    	if(i < 1){
		    		return '0';
		    	}else if(size > 100){
		    		size /= 1024;i++;
		    	}
		    }
		    
		    return size.toFixed(1) + units[i];
		},
		/**
		 * 使用*隔字替换字符 例：好*学*天*向*
		 */
		formatName : function (str){
		    var len = str.length, newstr = "";
		    for(var i=0; i<len; i++){
		        if(i%2 == 1){
		            newstr += '*';
		        }else{
		            newstr += str.substr(i, 1);
		        }
		    }
		    return newstr;
		},
		//对敏感内容进行打码
		mosaics : function(str, n,m){
			n = n || 3;
			m = m || 3;
			var tmpArr = [];
		    for ( var i = 0; i < m; i++)
		        tmpArr.push('*');
			
			return str.slice(0, n) + tmpArr.join("") + str.slice(str.length - n);
		},
		
		/**
		 * 时间戳转时间
		 * @param {String} formart	时间格式，Y年，M月，D日，H小时，I分钟，S秒，默认：Y-M-D H:I:S
		 * @param {int} timestamp	时间戳值	//默认当前时间
		 * @param {int} type		时间戳类型，1秒级时间戳，2毫秒级时间戳，默认1
		 */
		formartTime : function(formart, timestamp, type){
			formart	= formart || "Y-M-D H:I:S";
			type	= type || 1;
			var time = timestamp ? new Date(type == 1 ? timestamp * 1000 : timestamp) : new Date();
			formart = formart.replace('Y', time.getFullYear());
			formart = formart.replace('M', this.addZero(time.getMonth() + 1));
			formart = formart.replace('D', this.addZero(time.getDate()));
			formart = formart.replace('H', this.addZero(time.getHours()));
			formart = formart.replace('I', this.addZero(time.getMinutes()));
			formart = formart.replace('S', this.addZero(time.getSeconds()));
			return formart;
		},
		
		/**
		 *给数字加前导0 
		 */
		addZero : function (__d) {
		    if (__d < 10) {
		        __d = '0' + __d;
		    }
		    return __d
		},
		/**
		 * 倒计时
		 */
		countDown : function(options){
			var config = {
				element : '',		//筛选的元素
				startTime : 0,		//开始时间戳
				endTime : 0,		//结束时间戳
				callback : null,	//回调函数
				onlySecond : false,	//只显示秒数
				full: false,		//默认false； 是否显示完整倒计时时间；false表示天数和小时数为零时将不显示，true为显示
				format : '剩余：%s',	//格式化字符串
				day : '%s天',
				hour : '%s时',
				minute : '%s分',
				second : '%s秒',
				msec : '%s毫秒',
			}, self = this;
			
			if(options){
				for(var i in options){
					config[i] = options[i];
				}
			}
			
			countDown();
			
			
			function countDown(){
				var t = config.endTime - config.startTime;
				if(t <= 0){
					if(config.callback){
						config.callback();
					}
					return ;
				}
				if(config.onlySecond){
					var sStr = config.second.replace('%s', Tools.addZero(t));
					$(config.element).html(config.format.replace('%s', sStr));
					config.startTime ++;
					setTimeout(function(){countDown()}, 1000);
					return ;
				}
				
				var d = Math.floor(t / 60 / 60 / 24);
		        var h = Math.floor(t / 60 / 60 % 24);
		        var m = Math.floor(t / 60 % 60);
		        var s = Math.floor(t % 60);
		        
		        var dStr = config.day.replace('%s', Tools.addZero(d));
		        var hStr = config.hour.replace('%s', Tools.addZero(h));
		        var mStr = config.minute.replace('%s', Tools.addZero(m));
		        var sStr = config.second.replace('%s', Tools.addZero(s));
		        
		        if(d <= 0 && config.full == false){
		        	dStr = '';
		        	if(h <= 0) hStr = '';
		        }
				$(config.element).html(config.format.replace('%s', dStr + hStr + mStr + sStr));
				config.startTime ++;
				setTimeout(function(){countDown()}, 1000);
			}
		},
		
		/**
		 * 请求接口数据
		 * @param {String | Object} data	请求的参数，字符串则表示URL，其他则为配置项
		 * @return {void} 
		 */
		request : function(data, param, callback, checkLogin){
			var conf	= {
				url : '',
				data : {},
				success : function(){},
				error : function(){},
				waiting : '加载中...',
				autoCloseWaiting : true,
				checkLogin : true
			}, self = this,waiting=null, netHd = null;
			
			if(!Tools.getNetworkStatus()){
				Tools.notice('请求超时，请检查网络是否正常');
				return false;
			}
			
			//判断传入的是否字符串
			if("string" == typeof data){
				conf.url 	= data;
			}else{
				for(var m in data){
					conf[m]	= data[m];
				}
			}
			//判断参数类型
			if($.isFunction(param)){
				conf.success	= param;
				if(typeof callback != 'undefined') conf.checkLogin = checkLogin ? true : false;
			}else if($.isPlainObject(param)){
				conf.data	= param;
			}
			if($.isFunction(callback)){
				conf.success	= callback;
				if(typeof checkLogin != 'undefined') conf.checkLogin = checkLogin ? true : false;
			}
			
			//判断请求对象是否已创建
			netHd	= new plus.net.XMLHttpRequest();
			netHd.responseType	= 'json';
			
			//遍历参数，将对象值参数进行转换
			for(var i in conf.data){
				conf.data[i] = (typeof conf.data[i] != 'string') ? JSON.stringify(conf.data[i]) : conf.data[i];
			}
			
			//拼合请求基础数据
			conf.data.appid		= APPID;
			conf.data._platform	= 2;	 //标示是APP来源
			conf.data._version	= VERSION;
			conf.data.t			= this.getTimestamp();
			//判断是否存在登录标识
			var token = this.getLocal('_login_token_');
			if(token){
				conf.data.token = token;
			}
			
			var dataStr = getSignString(conf.data);
			
			//加载开始时显示等待框
			netHd.onloadstart=function(e){
				waiting = conf.waiting ? self.waiting(conf.waiting) : null;
			}
			netHd.timeout = 50000;	//设置超时时间，10000毫秒
			
			//设置请求的方式和URL
			netHd.open("POST", SERVER_URL + conf.url);
			//设置请求的签名信息
			netHd.setRequestHeader('x-sign',signString(conf.data));
			netHd.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			//发送请求 
			netHd.send(dataStr); 
			
			//出错时的方法
			netHd.onerror=function(e){
				Tools.notice('网络请求失败，请联系在线客服');
				waiting && waiting.close();
				conf.error({type:0, data : e});
			};
			
			netHd.ontimeout = function(){
				Tools.notice('请求超时，请检查网络是否正常');
				waiting && waiting.close();
				conf.error({type:1, data : '网络请求失败'});
			};
			
			netHd.onload=function(e){
				try{
					//判断是否需要登陆
					if(conf.checkLogin && (netHd.response.error == 10010 || netHd.response.error == 10011)){
						if(conf.autoCloseWaiting){
							waiting && waiting.close();
						}
						Tools.login(function(){
							//登陆成功后的回调
		                    Tools.getCurrentWindow().reload();
						});
						conf.error({type:3});
						return false;
					}
					conf.success(netHd.response);
				}catch(e){
					conf.error({type:2, data : e});
				}
				if(conf.autoCloseWaiting){
					waiting && waiting.close();
				}
			}
		},
		
		/**
		 * 获取当前手机的秒级时间戳
		 * @param {String} time	需要转换的文本型时间，默认当前时间 | 服务器-本地时间的时间差（秒）
		 * @param {Int} type	转换成的类型。1.秒级时间戳（默认），2.毫秒级时间戳
		 */
		getTimestamp : function(time, type){
			var date, timeDiffer = 0;
			if($.isNumeric(time)){
				date = new Date();
				timeDiffer = time;
			}else{
				date = time ? new Date(time.replace(/\-/g,'/')) : new Date();
			}
			type	= type || 1;
			
			if(type == 1){
				return parseInt(date.getTime() / 1000) + timeDiffer;
			}
			return date.getTime() + (timeDiffer * 1000);
		},
		
		/**
		 * 写入本地数据
		 */
		setLocal : function(key, val){
			if(!key || typeof key != 'string'){
				throw new Error('Key must be a string!');
			}
			var value = '';
			
			if(typeof val == 'string' || typeof val == 'number'){
				value = val;
			}else if($.isArray(val) || $.isPlainObject(val)){
				value = JSON.stringify(val);
			}else{
				throw new Error('Val must be a string or object!');
			}
			
			plus.storage.setItem(key, value);
		},
		
		/**
		 * 读取本地数据
		 */
		getLocal : function(key){
			if(!key || typeof key != 'string'){
				throw new Error('Key must be a string!');
			}
			var value = plus.storage.getItem(key);
		    try{
		        value = JSON.parse(value);
		    }catch(e){}
		    
		    return value;
		},
		
		/**
		 * 移除本地数据指定项，或清空本地存储
		 */
		removeLocal : function(key){
			//不传就清空
			if(typeof key=="undefined"){
				if(this.os.ios){
					plus.storage.clear();
				}else{
					window.localStorage.clear();
				}
			}
			if(!key || typeof key != 'string'){
				throw new Error('Key must be a string!');
			}
			plus.storage.removeItem(key);
		},
		
		/**
		 * 判断是否已登录
		 */
		checkLogin : function(){
			var token = this.getLocal('_login_token_');
			if(token){
				return true;
			}
			return false;
		},
		
		/**
		 * 登陆成功后设置token
		 */
		logined : function(login){
			this.setLocal('_login_token_', login.token);
			this.setUser(login);
			this.broadcast('login');
		},
		
		/**
		 * 获取登陆的用户信息
		 */
		getUser : function(){
			return this.getLocal('_login_user_info_');
		},
		
		/**
		 * 设置用户信息
		 */
		setUser : function(user){
			this.setLocal('_login_user_info_', user);
		},
		
		/**
		 * 监听事件方法
		 */
		listen : function(type, fun){
			if(typeof fun == 'function'){
				window.addEventListener(type, fun);
			}
		},
		
		/**
		 * 发送全局广播事件
		 */
		broadcast : function(type){
			var allPages	= plus.webview.all();
			for(var i in allPages){
				allPages[i].evalJS('window.dispatchEvent(new Event("'+type+'"))');
			}
		},
		
		/**
		 * 监听登陆方法
		 */
		onLogin : function(fun){
			this.listen('login', fun);
		},
		
		/**
		 * 退出登陆后清空Token
		 */
		logout : function(){
			this.removeLocal('_login_token_');
			this.broadcast('logout');
			plus.navigator.removeSessionCookie();
		},
		
		
		/**
		 * 监听退出方法
		 */
		onLogout : function(fun){
			this.listen('logout', fun);
		},
		
		/**
		 * 设置最顶端的webview的状态栏颜色为当前状态栏颜色
		 */
		setTopWindowStatusBar : function(){
			try{
				var wv = plus.webview.getTopWebview();
				wv.evalJS('try{Tools.setStatusBar();}catch(e){}');
			}catch(e){}
		},
		
		/**
		 * 设置剪切板
		 */
		setClipboard : function(val){
			plus.ypzan.setClipboard(val);
		},
		
		/**
		 * 读取剪切板
		 */
		getClipboard : function(){
			return plus.ypzan.getClipboard();
		},
		
		/**
		 * 打开推广方式的链接
		 */
		openUrl : function(url, title){
			if(url.indexOf('#try') >0){
	            //如果是商品详情，获取id
	            var id = url.match(/\#try(\d+)/);
            	return Tools.taskDetail(id[1], 1);
	        }else if(url.indexOf('#team') >0){
				//如果是商品详情，获取id
				var id = url.match(/\#team(\d+)/);
				return Tools.taskDetail(id[1], 2);
			}else if(url.indexOf('#zore') >0){
				//如果是商品详情，获取id
				var id = url.match(/\#zore(\d+)/);
				return Tools.taskDetail(id[1], 3);
			}else if(url.indexOf('detail') >0){
	            //如果是商品详情，获取id
	            var id = url.match(/(\d+)\.html/);
            	return Tools.taskDetail(id[1], 0);
	        }else if(url.indexOf('#share_page') >0){
	        	//跳转赚钱分享页面
	        	return Tools.jumpH5('activity/invite.html', '邀请有奖');
//              jump('share-make-money');
            }else if(url =='#'){
                return false;
	        }else{
	        	return Tools.openWeb(url, title);
	        }
		},
		
		/**
		 * 解析外部URL，并返回解析后的信息
		 */
		parseOpenUrl : function(url){
			if(url =='#'){
                return false;
	        }
			var urlObj	= this.parseURL(url);
			//非亿品赞内部页面
			if(!/^.*?ypzan\.(cn|com)/.test(urlObj.host)){
				Tools.openWeb(url);
				return ;
			}
			//处理亿品赞内部页面
			
			
			
		},
		
		/**
		 * 上传方法打包
		 * @param {Object} option	上传配置
		 * @param {Function} callback	上传成功后的回调
		 * @return {void}
		 */
		upload : function(type, callback, start){
			type	= type || '';
			callback	= callback || function(){};
			start		= start || function(){};
			
			
			Tools.actionSheet('', [{title:"拍照"},{title:"从相册选择"}], function(e){
				if(e.index == 1){	//拍照
					plus.camera.getCamera().captureImage( function(path){
						zipImg(path);
					}, function(e){
						console.log('Failed: '+e.message);
					}, {filename:"_doc/camera/"});
					
				}else if(e.index == 2){	//相册
					plus.gallery.pick(function(path){
						zipImg(path);
				    }, function(err){
				        console.log('Failed: '+err.message);
				    });
				}
			});
			
			//压缩图片
			function zipImg(path){
				var mPath = '_doc/temp/'+parseInt(Math.random() * 10000000)+'.jpg';
				plus.zip.compressImage({
					src:path,
					dst:mPath,
					overwrite:true,
					format:'jpg',
					width:'600px'
				},
				function() {
					doUpload(mPath);
				},function(error) {
					t.error('图像压缩失败，请重新选择图片');
				});
			}
			
			//上传
			function doUpload(path){
				start();
				var upload = plus.uploader.createUpload( SERVER_URL + 'public.image.upload', {}, 
					function(upload, status){
						if (status == 200) {
							//上传成功
							try{
								var response = JSON.parse(upload.responseText);
								callback(response);
							}catch(e){
								console.log(e);
							}
						}else{
							//上传失败
							Tools.error('上传失败，请联系在线客服');
						}
					}
				), data;
				
				data	= {appid:APPID+'', _platform:PLATFORM+'', t:Tools.getTimestamp()+'', type : type, _version : VERSION+''};
				upload.addData("appid", data.appid);
				upload.addData("_platform", data._platform);
				upload.addData("_version", data._version);
				upload.addData("t", data.t);
				upload.addData("type", data.type);
				//判断是否存在登录标识
				var token = Tools.getLocal('_login_token_');
				if(token){
					data.token = token;
					upload.addData("token", token);
				}
				upload.addFile(path, {key:"file"});
				upload.setRequestHeader('x-sign',signString(data));
				upload.start();
			}
		},
		
		/**
		 * 下载文件到本地
		 */
		download : function(url, callback, gallery){
			var local	= '_downloads/';
			callback	= callback || function(){};
			gallery		= typeof gallery == 'undefined' ? true : gallery;
			//开始下载
			plus.downloader.createDownload( url, {
				filename : local
			}, function(download, status){
				if(status == 200){
					if(gallery){
						plus.gallery.save( download.filename, function(){
							callback(1, download.filename);
						}, function(e){
							callback(0, e.message);
						});
					}else{
						callback(1, download.filename);
					}
				}else{
					callback(0, '下载失败');
				}
			}).start();
		},
		
		/**
		 * 第三方登陆
		 * @param {String} type 	平台类型：qq,weixin
		 * @param {Object} callback	回调方法
		 */
		thirdLogin : function(type, callback){
			var w = Tools.waiting();
			callback	= callback || function(){};
			//获取当前支持的登陆类型
			plus.oauth.getServices( function(services){
				for(var i in services){
					if(services[i].id == type){
						var auth = services[i];
						if(auth.userInfo){
							auth.logout(function(){
								login(auth);
							},error);
						}else{
							login(auth);
						}
						break;
					}
				}
			}, error);
			//登陆过程
			function login(auth){
				auth.login(function(){
					auth.getUserInfo( function(){
						w&&w.close();w=null;
						var userinfo	= {};
						userinfo.unionid	= auth.authResult.unionid || '';
						userinfo.openid		= auth.authResult.openid;
						userinfo.nickname	= auth.userInfo.nickname || '';
						userinfo.gender		= auth.userInfo.gender || (auth.userInfo.sex == 1 ? '男' : '女');
						userinfo.province	= auth.userInfo.province || '';
						userinfo.city		= auth.userInfo.city || '';
						userinfo.headimg	= auth.userInfo.figureurl_qq_2 || auth.userInfo.headimgurl || '';
						callback(userinfo);
					}, error);
				},error);
			}
			//出错时的方法
			function error(e){
				w&&w.close();w=null;
				console.log(JSON.stringify(e));
			}
			//应用切换后台时关闭等待提示，避免取消授权时出现等待一直存在情况
			document.addEventListener("pause",function(){
				setTimeout(function(){
					w&&w.close();w=null;
				},2000);
			}, false );
		},
		
		/**
		 * 打开登陆窗口
		 */
		login : function(fun){
			//登陆成功的回调方法
			fun	= fun || function(){};
			var that = this;
			
			var login = that.os.ios ? this.openWindowWithNav('login.html', {}, '','transparent') : this.openWindow('login.html');	//Tools*.openWindow('login.html', {}, null, true, 1, null);
			if(login){
				login.addEventListener("rendered", function() {
	                try{
	                	w.VG.method(login, "call", {}, fun);
	                }catch(e){}
	                if(!that.os.ios){
                        setTimeout(function(){
                            loading.close();
                        }, 500);
                    }
	            });
                if(!that.os.ios) {
                    var loading = new plus.nativeObj.View("loading",
                        {top:"0px",left:'0px',height:'170px',width:'100%'},
                        [
                        {tag:'img',id:'bg',src:'_www/img/bg_login.png',position:{top:'0px',left:'0px',width:'100%',height:'100%'}},
                        {tag:'font',id:'logo',text:'\ue668',textStyles:{color:'#FFFFFF',size:'70px',fontSrc:'_www/fonts/iconfont.ttf'},position:{top:'52px',left:'0px',height:'71px',width:'100%'}},
                        ]);
                    login.append(loading);
                    //绘制返回按钮
                    var back = new plus.nativeObj.View("back",{top:(immersed + 5)+'px',left:'5px',height:'30px',width:'30px'},[
                        {tag:'font',id:'back',text:'\ue61e',textStyles:{color:'#FFFFFF',size:'20px',fontSrc:'_www/fonts/iconfont.ttf'},position:{top:'0px',left:'0px'}}
                    ]);
                }
				back.addEventListener('click', function(){
					login.close();
					Tools.broadcast('login_close');
				}, false);

                if(!that.os.ios) {
                    login.append(back);
                }
			}
            this.logout();
            return login;
		},
		
		/**
		 * 打开商品详情
		 * @param {int} id	活动ID
		 * @param {bool} isTry	是否免费试用，0 否，1 是 ，2 拼团活动, 3 零元试用
		 */
		taskDetail : function(id, isTry, detail){
			var wb,buttons	= [
				Tools.window.button('more', function(){
					wb.evalJS('more_icon('+(44+immersed)+');');
				}),
				Tools.window.button('share',function(){
					wb.evalJS('doShare();');
				}),
			];
			if(isTry==2){
				wb = Tools.openWindowWithNav('detail_pt.html', {hid : id, info : detail}, '拼团详情','transparent', buttons, false, undefined, 'detail_pt_'+id);
			}else if(isTry==1){
				wb = Tools.openWindowWithNav('detail_try.html', {hid : id, info : detail}, '试用详情','transparent', buttons, false, undefined, 'detail_try_'+id);
			}else if(isTry==3){
				wb = Tools.openWindowWithNav('detail_zero.html', {hid : id, info : detail}, '0元详情','transparent', buttons, false, undefined, 'detail_zero_'+id);
			}else{
				wb = Tools.openWindowWithNav('detail.html', {hid : id, info : detail}, '活动详情','transparent', buttons, false, undefined, 'detail_'+id);
			}
			return wb;
		},
		
		/**
		 * 打开对应帮助页面
		 */
		gotoHelp : function(name){
			this.openWeb(this.getConfig('www_url') + 'help/detail/'+name+'.html');
		},
		/**
		 * 打开对应帮助页面
		 */
		helpCenter : function(){
			this.openWeb(this.getConfig('www_url') + 'help/index.html');
		},
		
		/**
		 * 获取移动端配置
		 */
		getConfig : function(name){
			var config = Tools.getLocal('APP_CONFIG');
			if(name){
				return config[name];
			}
			return config;
		},
		
		/**
		 * 保留小数位
		 */
		fixed : function(flt, bit){
			bit	= typeof  bit == 'undefined' ? 2 : bit;
			return flt.toFixed(bit);
		},
		
		/**
		 * 获取网络状态
		 * @return {int} 0：无网络， 1： WiFi， 2：流量
		 */
		getNetworkStatus : function (){
			var nt = plus.networkinfo.getCurrentType();
			switch (nt){
				case plus.networkinfo.CONNECTION_ETHERNET:
				case plus.networkinfo.CONNECTION_WIFI:
					//WiFi
					return 1;
					break; 
				case plus.networkinfo.CONNECTION_CELL2G:
				case plus.networkinfo.CONNECTION_CELL3G:
				case plus.networkinfo.CONNECTION_CELL4G:
					//流量
					return 2;
					break; 
				default:
					//无网络
					return 0;
					break;
			}
		},
		
		/**
		 * 监听网络状态改变
		 */
		onNetChange : function(fun){
			var self = this;
			document.addEventListener("netchange", function(){
				fun(self.getNetworkStatus());
			}, false);
		},
		
		/**
		 * 检查系统更新
		 * @param {Object} callback
		 */
		update : function(callback){
			this.request({
				url : 'public.system.checkupdate',
				data : {
					version:VERSION,
					vs:plus.runtime.version,
					platform : PLATFORM
				},
				waiting : false,
				checkLogin : false,
				success : function(data){
					if(data.error == 0){
						callback(1, data.body);
					}else{
						callback(0);
					}
				}
			});
		},
		
		/**
		 * 提示更新信息框
		 * @param {int} type 提示类型，1.强制  2.提示
		 * @param {Object} data
		 */
		updateBox : function(type, data){
			var t = this,btns = [];
			
			if(parseInt(type) == 1){
				btns = ['立即升级'];
			}else{
				btns = ['立即升级', '取消'];
			}
			t.confirm(data.content, function(e){
				//开始升级
				if(e.index == 0){
					// if($.os.ios){	//ios则打开App Store对应地址
						plus.runtime.openURL(data.url);
					// }else{	//安卓下载应用并安装
						//提示切换到后台下载
						// plus.nativeUI.toast('更新程序已切换到后台下载...');
						// plus.ypzan.update(data.url);
					// }
				}
			}, btns, data.title || '有新版本发布啦~~');
		},
		
		/**
		 * 静默方式进行增量更新
		 */
		incUpdate : function(data){
			var url = data.url, that = this;
			this.download(url, function(status, file){
				if(status == 1){
					plus.runtime.install(file,{},function(){
						that.alert('APP已完成升级，重启当前APP即可生效', '立即重启', '系统信息', function () {
							plus.runtime.restart();
						})
	        		},function(e){/* 升级失败  */});
				}
			}, false);
		},
		
		/**
		 * 检查是否是手机号
		 */
		checkMobile : function(str){
			return /^1[3-9][\d]{9}$/.test(str);
		},
		
		/**
		 * 网页端唤醒APP
		 */
		webCall : function(){
			var args= plus.runtime.arguments,self = this;
			if(args){
				try{
					var url =  self.parseURL(args);
					if(url.protocol == 'ypzan'){
						url = JSON.parse(url.params.params);
						url && url.toUrl && self.openUrl(url.toUrl);
					}
				}catch(e){console.log('WebCallError : '+e);}
			}
		},
		
		/**
		 * 在标题栏绘制
		 */
		drawOnTitleNav : function(fun){
			var draw  = fun();	//获取需要绘制的内容
			if(!draw) return false;
			var title = this.getCurrentWindow().getTitleNView();
			title.draw(draw);
		},
		
		/**
		 * 重置标题栏
		 */
		resetTitleNav : function(){
			var title = this.getCurrentWindow().getTitleNView();
			
			title.restore();
		},
		
		/**
		 * 跳转对应的H5页面
		 */
		jumpH5 : function(url, title){
			return this.openWeb(this.getConfig('www_url') + url, title);
		},
		
		parseURL : function (url) {　　
			var a = document.createElement('a');
			a.href = url;
			return {
				source: url,
				protocol: a.protocol.replace(':', ''),
				host: a.hostname,
				port: a.port,
				query: a.search,
				params: (function() {
					var ret = {},
						seg = a.search.replace(/^\?/, '').split('&'),
						len = seg.length,
						i = 0,
						s; //len = 2
					for(; i < len; i++) {
						if(!seg[i]) {
							continue;
						}
						s = seg[i].split('=');
						ret[s[0]] = s[1];
					}
					return ret;
				})(),
				file: (a.pathname.match(/\/([^\/?#]+)$/i) || [, ''])[1],
				hash: a.hash.replace('#', ''),
				path: a.pathname.replace(/^([^\/])/, '/$1'),
				relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [, ''])[1],
				segments: a.pathname.replace(/^\//, '').split('/')
			};
		},
		
		getOrderCount : function (fun){
			var self = this;
			if(orderCountLoading){
				setTimeout(function(){
					self.getOrderCount(fun);
				}, 1000);
				return ;
			}
			orderCountLoading = true;
			if(self.checkLogin()){
				try{
					var orderCount = self.getLocal('USER_LOCAL_COUNT');
					var countTime  = self.getLocal('USER_LOCAL_COUNT_TIME');
					//10秒刷新一次数据
					if(!orderCount || (self.getTimestamp() - self.getTimestamp(countTime) > 10)){
						self.request({
				    		url : 'order.count.get',
							waiting : false,
				    		success : function(data){
					    		if(data.error == 0){
					    			try{
						    			self.setLocal('USER_LOCAL_COUNT', data.body);
						    			self.setLocal('USER_LOCAL_COUNT_TIME', self.formartTime());
					    			}catch(e){}
					    			orderCountLoading = false;
					    			fun(data.body);
					    		}
				    		}
				    	});
					}else{
						orderCountLoading = false;
						fun(orderCount);
					}
				}catch(e){
					orderCountLoading = false;
					setTimeout(function(){
						self.getOrderCount(fun);
					}, 500);
				}
			}else{
				try{
					//未登录的清空数据
	    			self.removeLocal('USER_LOCAL_COUNT');
	    			self.removeLocal('USER_LOCAL_COUNT_TIME');
				}catch(e){}
				//未登录则直接为false
				fun(false);
			}
		},
		
		/**
		 * 抓取淘宝信息
		 */
		getInfoFromTb : function(callback){
			callback = typeof callback == 'function' ? callback : function(){};
			var self = this, geted = false;
			
			window.tbInfoFunction	= function(nick, score){
				if(geted) return;
				//处理淘气值获取的值
				score = score.replace(/[^0-9]/ig,"");
				geted = true;
				callback(nick, score);
			}
			
			var web = self.openWeb('https://i.taobao.com/my_taobao.htm');
			web.addEventListener('rendered', function(){
				if(web.getURL().indexOf('i.taobao.com')){
					var js = 'var nick = document.getElementsByClassName("site-nav-login-info-nick")[0].innerText;'
							+ 'var score = document.getElementsByClassName("tao-score")[0].innerText;'
							+ 'plus.webview.currentWebview().opener().evalJS("window.tbInfoFunction(\\""+nick+"\\", \\""+score+"\\")")';
					
					var timer = setInterval(function(){
						web.evalJS(js);
						if(geted){
							clearInterval(timer);
							web.hide();
							plus.navigator.removeAllCookie();
							web.close();
						}
					}, 500);
					
				}
			
			})
			
		},
		
		/**
		 * 抓取京东信息
		 */
		getInfoFromJd : function(callback){
			callback = typeof callback == 'function' ? callback : function(){};
			var self = this, geted = false;
			
			window.jdInfoFunction	= function(nick, score,level){
				if(geted) return;
				//处理淘气值获取的值
				score = score.replace(/[^0-9]/ig,"");
				level = level.replace(/[^0-9]/ig,"");
				nick = nick.replace("用户名：","");
				geted = true;
				callback(nick, score, level);
			}
			
			var web = self.openWeb('https://home.m.jd.com/myJd/home.action');
			web.addEventListener('rendered', function(){
				if(web.getURL().indexOf('home.m.jd.com')){
					var js = 'var nick = document.getElementsByClassName("pin")[0].children[0].innerText;'
							+ 'var level = document.getElementsByClassName("vip")[0].getAttribute("class");'
							+ 'var score = document.getElementsByClassName("notice")[0].innerText;'
							+ 'plus.webview.currentWebview().opener().evalJS("window.jdInfoFunction(\\""+nick+"\\", \\""+score+"\\", \\""+level+"\\")")';
					
					var timer = setInterval(function(){
						web.evalJS(js);
						if(geted){
							clearInterval(timer);
							web.hide();
							plus.navigator.removeAllCookie();
							web.close();
						}
					}, 500);
					
				}
			
			})
			
		},
		
		/**
		 * 获取设备当前位置信息
		 */
		getLocation : function(fun, err){
			fun	= typeof fun == 'function' ? fun : function(){};
			err = typeof err == 'function' ? err : function(){};
			plus.geolocation.getCurrentPosition(fun, err, {geocode : false})
		},
		
		/**
		 * 监听推送消息
		 */
		pushListener : function(){
			var self = this;
			//监听点击消息
			plus.push.addEventListener('click', function(msg){
				self.gotoAction($.type(msg.payload) == 'string' ? JSON.parse(msg.payload) : msg.payload);
			}, false );
			//获取设备标识
			var cinfo = plus.push.getClientInfo();
			if(cinfo && cinfo.clientid){
				self.setLocal('device_push', cinfo);
				//提交设备标识到服务端
				self.request({
					url : 'push.device',
					waiting : false,
					data : { cid : cinfo.clientid, tid : cinfo.token, type : 3 },
					success : function(data){
						if(data.error == 0){
							//设置当前的订阅状态
							t.setLocal('msg_subscribe', data.data.subscribe + '');
							
						}
					}
				});
			}
		},
		
		/**
		 * 监听滚动条位置
		 */
		listenScrollbar : function(offset, callback){
			offset	= offset || 0;
			if(typeof callback == 'function'){
				$(window).scroll(function () {
		            if ($(document).scrollTop() >= ($(document).height() - $(window).height() - offset)) {
		                callback();
		            }
		        });
			}
		},
		
		/**
		 * 页面下拉刷新和上拉加载的配置
		 */
		pageUpDown : function(options){
			var self = this, up = down = {}, msgBox,
				wv = self.getCurrentWindow();
			//提取提示信息标签.如不存在则自行创建
			msgBox = $(options.container).find('.pullUpInfoMsg');
			if(msgBox.length <= 0){
				msgBox = $('<div>').addClass('pullUpInfoMsg').appendTo(options.container);
			}
			
			if(options.down){
				down = options.down || {};
				down.auto = down.auto || false;
				down.nativeAuto = down.nativeAuto || false;
				down.support  = true;
				down.waiting  = down.waiting || '正在加载数据...';
				down.callback = down.callback || function(){};
				down.style 	= down.style || 'circle';
				down.height   = down.height || '100px';	//窗口的下拉刷新控件高度
				down.range    = down.range || '200px';		//窗口可下拉拖拽的范围
				down.offset   = down.offset || '0px';	//下拉刷新控件的起始位置
				down.contentdown	= down.contentdown || {caption:'下拉可以刷新'};
				down.contentover	= down.contentover || {caption:'释放开始刷新'};
				down.contentrefresh = down.contentrefresh || {caption:'正在刷新...'};
				down.loaded = function(){
					wv.endPullToRefresh();
					msgBox.html('').hide();
				}
				down.loading = function(){
					if(down.nativeAuto){
						wv.beginPullToRefresh();
					}else{
						msgBox.html(down.waiting).show();
						//异步执行
						setTimeout(function(){
							down.callback();
						}, 10);
					}
				}
				//设置窗口下拉方法
				wv.setPullToRefresh(down, function(){
					try{
						msgBox.html('');
						down.callback();
					}catch(e){
						wv.endPullToRefresh();
					}
				});
				if(down.auto){
					down.loading();
				}
			}
			
			if(options.up){
				var endUp = loading = false;
				up = options.up || {};
				up.offset	= typeof up.offset == 'undefined' ? 100 : up.offset;	//距离底部多少像素时触发上拉事件
				up.waiting  = up.waiting || '正在加载数据...';
				up.endData  = up.endData || '没有更多数据了';
				up.loaded 	= function(){
					msgBox.html('');
					loading = false;
				}
				up.endUp 	= function(status){
					if(status){
						if(up.endTextHidden){
							msgBox.hide();
						}else{
							msgBox.html(up.endData).show();
						}
						if(up.endCallback){
							up.endCallback();
						}
						endUp = true;
					}else{
//						msgBox.html('');
						endUp = false;
					}
				}
				
				self.listenScrollbar(up.offset, function(){
					if(endUp || loading) return ;
					loading = true;
					msgBox.html(up.waiting).show();
					try{
						up.callback();
					}catch(e){loading = false;}
				});
			}
			return {
				downed : down.loaded,
				downing : down.loading,
				uped : up.loaded,
				upEnd : up.endUp
			};
		},
		/**
		 * 结束下拉刷新
		 */
		endDowning : function(wv){
			wv = wv || this.getCurrentWindow();
			wv.endPullToRefresh();
		},
		
		/**
		 * 开始下拉刷新
		 */
		beginDowning : function(wv){
			wv = wv || this.getCurrentWindow();
			wv.beginPullToRefresh();
		},
		
		/**
		 * 根据配置的参数,跳转到指定页面,或打开指定URL
		 */
		gotoAction : function(actions){
			console.log(JSON.stringify(actions));
			var self = this, listPage = {allList : 0, superList : 1 , tryList : 2, gcoinList : 3, groupList:4, zeroList:5};
			switch(parseInt(actions.type)){
				case BTN_JUMP_TYPE_INSIDE:
					var btns = [];
					switch(actions.url){
						case 'allList':
						case 'superList':
						case 'tryList':
						case 'gcoinList':
						case 'groupList':
						case 'zeroList':
							actions.extend.param = actions.extend.param || {}
							actions.extend.param.type = listPage[actions.url];
							self.showTaskListPage(actions.extend.param);
							break;
						case 'tryDetail':
						case 'superDetail':
						case 'groupDetail':
						case 'zeroDetail':
							var detail_url = {superDetail:0, tryDetail:1, groupDetail:2, zeroDetail:3};
							self.taskDetail(actions.extend.param.hid || 0, detail_url[actions.url]);
							break;
						case 'buyerIndex':
							btns = [
								self.window.button("", function() {
									var follow = Tools.openWindowWithNav('user_follow.html', {}, '我的关注', 'default', [
										Tools.window.button("more", function() {follow.evalJS('more_icon();');}, {fontSize: '24px'})
									], true);
								}, {fontSize: '22px',text: '\ue641'})
							];
						case 'newPreview':
							var url = actions.url == 'buyerIndex' ? 'buyers_show.html' :'list_today.html';
							self.openWindowWithNav(url, actions.extend.param || {}, actions.title, "default", btns);
							break;
						case 'order':
							$('.footer_ico#order').trigger('click');
							break;
						case 'userCenter':
							$('.footer_ico#user').trigger('click');
							break;
						case 'index':
							Tools.getIndexWindow().show();
							break;
						default:
							Tools.openWindowWithNav(actions.url, actions.extend.param || {}, actions.title, 'default', [], true);
							break;
					}
					break;
				case BTN_JUMP_TYPE_WAP:
					self.jumpH5(actions.url);
					break;
				case BTN_JUMP_TYPE_HELP:
					self.gotoHelp(actions.url);
					break;
				case BTN_JUMP_TYPE_URL:
					self.openUrl(actions.url);
					break;
			}
		},
		
		
		/**
		 * 打开活动列表
		 */
		showTaskListPage : function (data){
			var self = this;
			data	= data || {};

			/*var titleStyle	= self.window.title('商品总汇', 'default', "#FFFFFF", false, [
				self.window.button('search', function(){
					self.openWindow('search.html', {})
				}),
				self.window.button('', function(){
					self.openQrcode();
				},{text : '\ue60e', position : 'left', fontSize:'22px', color : '#353535'})
			]);*/
			var list = self.openWindow('list_shop.html', {filter: data}, null, true, 5);
			if(list.type == 1){
				list.filter = data;
				list.evalJS('doFilterEvent("clear")');
				if(!$.isEmptyObject(data)){
					for(var mn in data){
						list.evalJS('doFilterEvent("'+mn+'", "'+data[mn]+'")');
					}
				}
				list.evalJS('doFilterEvent("end")');
			}

			/*var  list = Tools.openWindow('list_shop.html', {}, '',false, '');
			setTimeout(function(){
					list.evalJS('listType("'+data.source+'");');
				},500);
				console.log(list.type);*/
		},
		
		/**
		 * 创建遮罩的弹层图片广告
		 * @param {Object} src 		图片地址
		 * @param {Object} width	内容最大宽度
		 * @param {Object} height	内容最大高度
		 * @param {Object} pos		展示位置: 0.居中;1.右下角
		 * @param {Object} mask		是否背景遮罩
		 * @param {Object} callback	点击的回调方法
		 */
		createLayer : function(src, mask, width, height, pos, callback){
			var popBg, popAdBox, popMain;
			if(mask){
				//放置遮罩背景
				popBg = $('<div>').css({
					position:'fixed', top:0, left:0, height:'100%',
					width:'100%', zIndex:998, backgroundColor:"rgba(0,0,0,0.5)"
				}).on('touchmove', function(){return false;}).appendTo('body');
			}
			//确定主题内容位置
			var boxCss = {maxWidth:width,maxHeight:height};
			if(pos){//右下角
				boxCss.right = "20px",boxCss.bottom	= "90px", boxCss.position = 'fixed', boxCss.zIndex = 997;
			}else{//居中
				boxCss.position = "relative",boxCss.display = 'inline-block',boxCss.margin = 'auto';
				popMain	= $('<div>').css({
					position:'fixed',textAlign:"center",left: "50%",width: "100%",top: "50%",
					WebkitTransform: "translate(-50%,-50%)",MsTransform: "translate(-50%,-50%)",transform: "translate(-50%,-50%)",zIndex:999
				}).on('touchmove', function(){return false;});
			}
			//放置主体内容
			popAdBox = $('<div>').css(boxCss)
			.append(
				$('<em>').addClass('ypzan').css({
					right:-10,top:-10,width:20,height:20,fontSize:'12px',border:'1px solid #999',background:'#666',
					color:'#FFF',borderRadius:'10px',textAlign:'center',lineHeight:'20px',position:'absolute',
				}).click(function(){
					popAdBox.remove(),mask && popBg.remove(), popMain && popMain.remove();
				}).html('&#xe61c;')
			).append(
				$('<img>').attr('src', src).css({maxWidth:"100%",maxHeight:"100%"})
				.click(callback).on('touchmove', function(){return false;})
			).on('touchmove', function(){return false;});

			if(pos){//右下角
				popAdBox.addClass('popAdBox').appendTo('body');
			}else{//居中
				popMain.append(popAdBox).appendTo('body');
			}
		},
		
		/*
		 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
		 * Digest Algorithm, as defined in RFC 1321.
		 * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
		 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
		 * Distributed under the BSD License
		 * See http://pajhome.org.uk/crypt/md5 for more info.
		 */
		md5 : function(str){
			
			/*
			 * Configurable variables. You may need to tweak these to be compatible with
			 * the server-side, but the defaults work in most cases.
			 */
			var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
			var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
			var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */
			
			/*
			 * These are the functions you'll usually want to call
			 * They take string arguments and return either hex or base-64 encoded strings
			 */
			function hex_md5(s){ return binl2hex(core_md5(str2binl(s), s.length * chrsz));}
			function b64_md5(s){ return binl2b64(core_md5(str2binl(s), s.length * chrsz));}
			function str_md5(s){ return binl2str(core_md5(str2binl(s), s.length * chrsz));}
			function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
			function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
			function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }
			
			/*
			 * Perform a simple self-test to see if the VM is working
			 */
			function md5_vm_test()
			{
			  return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
			}
			
			/*
			 * Calculate the MD5 of an array of little-endian words, and a bit length
			 */
			function core_md5(x, len)
			{
			  /* append padding */
			  x[len >> 5] |= 0x80 << ((len) % 32);
			  x[(((len + 64) >>> 9) << 4) + 14] = len;
			
			  var a =  1732584193;
			  var b = -271733879;
			  var c = -1732584194;
			  var d =  271733878;
			
			  for(var i = 0; i < x.length; i += 16)
			  {
			    var olda = a;
			    var oldb = b;
			    var oldc = c;
			    var oldd = d;
			
			    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
			    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
			    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
			    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
			    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
			    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
			    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
			    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
			    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
			    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
			    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
			    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
			    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
			    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
			    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
			    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);
			
			    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
			    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
			    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
			    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
			    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
			    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
			    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
			    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
			    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
			    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
			    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
			    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
			    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
			    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
			    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
			    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);
			
			    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
			    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
			    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
			    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
			    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
			    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
			    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
			    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
			    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
			    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
			    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
			    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
			    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
			    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
			    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
			    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);
			
			    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
			    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
			    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
			    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
			    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
			    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
			    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
			    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
			    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
			    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
			    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
			    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
			    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
			    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
			    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
			    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);
			
			    a = safe_add(a, olda);
			    b = safe_add(b, oldb);
			    c = safe_add(c, oldc);
			    d = safe_add(d, oldd);
			  }
			  return Array(a, b, c, d);
			
			}
			
			/*
			 * These functions implement the four basic operations the algorithm uses.
			 */
			function md5_cmn(q, a, b, x, s, t)
			{
			  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
			}
			function md5_ff(a, b, c, d, x, s, t)
			{
			  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
			}
			function md5_gg(a, b, c, d, x, s, t)
			{
			  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
			}
			function md5_hh(a, b, c, d, x, s, t)
			{
			  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
			}
			function md5_ii(a, b, c, d, x, s, t)
			{
			  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
			}
			
			/*
			 * Calculate the HMAC-MD5, of a key and some data
			 */
			function core_hmac_md5(key, data)
			{
			  var bkey = str2binl(key);
			  if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);
			
			  var ipad = Array(16), opad = Array(16);
			  for(var i = 0; i < 16; i++)
			  {
			    ipad[i] = bkey[i] ^ 0x36363636;
			    opad[i] = bkey[i] ^ 0x5C5C5C5C;
			  }
			
			  var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
			  return core_md5(opad.concat(hash), 512 + 128);
			}
			
			/*
			 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
			 * to work around bugs in some JS interpreters.
			 */
			function safe_add(x, y)
			{
			  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
			  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
			  return (msw << 16) | (lsw & 0xFFFF);
			}
			
			/*
			 * Bitwise rotate a 32-bit number to the left.
			 */
			function bit_rol(num, cnt)
			{
			  return (num << cnt) | (num >>> (32 - cnt));
			}
			
			/*
			 * Convert a string to an array of little-endian words
			 * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
			 */
			function str2binl(str)
			{
			  var bin = Array();
			  var mask = (1 << chrsz) - 1;
			  for(var i = 0; i < str.length * chrsz; i += chrsz)
			    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
			  return bin;
			}
			
			/*
			 * Convert an array of little-endian words to a string
			 */
			function binl2str(bin)
			{
			  var str = "";
			  var mask = (1 << chrsz) - 1;
			  for(var i = 0; i < bin.length * 32; i += chrsz)
			    str += String.fromCharCode((bin[i>>5] >>> (i % 32)) & mask);
			  return str;
			}
			
			/*
			 * Convert an array of little-endian words to a hex string.
			 */
			function binl2hex(binarray)
			{
			  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
			  var str = "";
			  for(var i = 0; i < binarray.length * 4; i++)
			  {
			    str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) +
			           hex_tab.charAt((binarray[i>>2] >> ((i%4)*8  )) & 0xF);
			  }
			  return str;
			}
			
			/*
			 * Convert an array of little-endian words to a base-64 string
			 */
			function binl2b64(binarray)
			{
			  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
			  var str = "";
			  for(var i = 0; i < binarray.length * 4; i += 3)
			  {
			    var triplet = (((binarray[i   >> 2] >> 8 * ( i   %4)) & 0xFF) << 16)
			                | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
			                |  ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
			    for(var j = 0; j < 4; j++)
			    {
			      if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
			      else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
			    }
			  }
			  return str;
			}
			return hex_md5(str);
		}
	};
	
	var immersed = 0;
	var ms=(/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
	if(ms&&ms.length>=3){
		immersed=parseFloat(ms[2]);
	}
	w.immersed = immersed;
	var sbb = document.getElementById('status_bar_bg')
	if(!immersed){
		sbb && (sbb.style.display = 'none');
		return;
	}
	var t=document.getElementById('header');
	t&&(t.style.paddingTop=immersed+'px',t.style.height=(immersed + 44)+'px')
	t=document.getElementById('content');
	t&&(t.style.marginTop=immersed+'px');
	t=document.getElementById('pre-content');
	t&&(t.style.paddingTop=immersed+'px');
	sbb && (sbb.style.height = immersed+'px');
	

	/**
	 * 创建于:2015-5-16<br>
	 * 支持回调的跨webview方法调用
	 * @author chender
	 * @version 0.9
	 * TODO 支持传递多个参数
	 */
    w.VG = new function() {
        var callbackPool = {};
        var callbackKey = "callbackKey_";
        var callbackIndex = 0;
        var curViewId = null;
        /** 
         * @description 向回调池里面新增一个callback函数,并返回索引值
         * @param {Function} callback=[] 回调函数
         * @return {String} 该回调函数的索引值，可通过该值获取到存放的回调函数
         */
        this.pushCallback = function(callback) {
                var key = callbackKey + (callbackIndex++);
                callbackPool[key] = callback;
                return key;
            }
            /** 
             * @description 通过索引值从回调池里面取出一个callback函数
             * @param {String} key=[] 回调函数索引值
             * @return {Function} 存放的回调函数
             */
        this.pullCallback = function(key) {
                var back = callbackPool[key];
                delete callbackPool[key];
                return back;
            }
            /**
             * @description 调用其他webview的方法，当前webview必须设置id值(方便回调)
             * @param {Webview} webview=[webview] 需要调用方法的webview
             * @param {String} methodName=[methodName] 需要调用的方法的名称
             * @param {JSON} param=[param] 调用时传递的参数，为json格式
             * @param {Function} callback=[callback] 回调函数
             */
        this.method = function(webview, methodName, param, callback) {
            curViewId = curViewId ? curViewId : (curViewId = plus.webview.currentWebview().id);
            if (curViewId == null) {
                var msg = "该webview没设置id,无法使用该功能";
                console.log(msg);
                throw new Error(msg);
            }
            if (webview == null) {
                var msg = "找不到对应的webview,webviewDd:" + webview;
                console.log(msg);
                throw new Error(msg);
            }
            var callbackKey = null;
            if (callback) {
                callbackKey = this.pushCallback(callback);
            }
            evalJS(webview, "VG._methodCalled", curViewId, methodName, JSON.stringify(param), callbackKey);
        }

        this._methodCalled = function(viewId, methodName, param, callbackKey) {
            //TODO 多参数如何实现
            var method = window.eval(methodName);
            method(JSON.parse(param), callbackKey && function(backParam) {
                evalJS(plus.webview.getWebviewById(viewId), "VG._methodBacked", callbackKey, backParam && JSON.stringify(backParam) || "");
            });
        }
        this._methodBacked = function(callbackKey, backParam) {
            var callback = this.pullCallback(callbackKey);
            callback(backParam && JSON.parse(backParam));
        }

        function evalJS(webview, methodName) {
            var params = "";
            if (arguments.length > 2) {
                for (var i = 2; i < arguments.length; i++) {
                    if (arguments[i] === null || arguments[i] === undefined) {
                        params += "null,";
                    } else {
                        params += "'" + arguments[i] + "',";
                    }
                }
                params = params.substring(0, params.length - 1);
            }
            webview.evalJS(methodName + "(" + params + ")");
        }
    }
    
    /**
     * 获取用来签名字符串
     * @param {Object} data
     * @return {String} 拼装好的字符串
     */
    function getSignString(data){
    	//按照参数顺序对参数进行拼接，并对参数值进行url编码
		var newkey = Object.keys(data).sort(), dataStr = [],m=0;
		for(var i=0; i < newkey.length; i++){
			if($.trim(data[newkey[i]])){
				dataStr[m]	= newkey[i]+'=' + encodeURIComponent($.trim(data[newkey[i]]));
				m++;
			}
		}
		return dataStr.join('&');
    }
    
    /**
     * 对签名字符串进行签名
     * @param {String} string
     * @return {String} 签名
     */
    function signString(data){
		if(!checkIsRelease()){
			return Tools.md5(Tools.md5(getSignString(data)) + Tools.md5(APPSECRIT));
		}
		return plus.ypzan.sign(data);
    }
    
})(window);

! function(a, b) {
	function c(c) {
		this.os = {};
		var d = [function() {
			var a = c.match(/(MicroMessenger)\/([\d\.]+)/i);
			return a && (this.os.wechat = {
				version: a[2].replace(/_/g, ".")
			}), !1
		}, function() {
			var a = c.match(/(Android);?[\s\/]+([\d.]+)?/);
			return a && (this.os.android = !0, this.os.version = a[2], this.os.isBadAndroid = !/Chrome\/\d/.test(b.navigator.appVersion)), this.os.android === !0
		}, function() {
			var a = c.match(/(iPhone\sOS)\s([\d_]+)/);
			if(a) this.os.ios = this.os.iphone = !0, this.os.version = a[2].replace(/_/g, ".");
			else {
				var b = c.match(/(iPad).*OS\s([\d_]+)/);
				b && (this.os.ios = this.os.ipad = !0, this.os.version = b[2].replace(/_/g, "."))
			}
			return this.os.ios === !0
		}];
		[].every.call(d, function(b) {
			return !b.call(a)
		})
	}
	c.call(a, navigator.userAgent)
}(Tools, window),


//托管返回键事件
plus.key.addEventListener("backbutton", Tools.doBack , false);
	
Tools.getCurrentWindow().addEventListener('show',function(){
	Tools.setStatusBar();
},false);

Tools.getCurrentWindow().addEventListener('close',function(){
	Tools.getIndexWindow().evalJS('setTimeout(function(){Tools.setTopWindowStatusBar();}, 800);');
},false);

Tools.getCurrentWindow().addEventListener('popGesture',function(){
	Tools.getIndexWindow().evalJS('setTimeout(function(){Tools.setTopWindowStatusBar();}, 100);');
},false);

Tools.ready(function(t){
	Tools.setStatusBar();
	//打开商品详情页面的方法
	$('body').on('click', '.openTaskDetail', function(){
		if($(this).hasClass("cur")){}else{
			var id = $(this).attr('item-id'), 
				type = $(this).attr('item-type');
			type = parseInt(type)-1;
			console.log(type);
			t.taskDetail(id, type);
		}
	});
	//打开H5页面
	$('body').on('click', '.gotoH5Url', function(){
		var url = $(this).attr('item-url');
		t.jumpH5(url);
	});
	//打开帮助详情页面
	$('body').on('click', '.gotoHelpUrl', function(){
		t.gotoHelp($(this).attr('item-type'));
	});
	//跳转到消息中心
	$('body').on('click', '.gotoMessageCenter', function(){
		var msgWd = t.openWindowWithNav("user_message.html", {}, '消息中心', 'default', [t.window.button("",function(){
				msgWd.evalJS('msgLook();');			
			},{fontSize : '22px',text : '\ue676'})
		], true);
	});
	//使用浏览器打开指定URL
	$('body').on('click', '.gotoWebUrl', function(){
		t.openUrl($(this).attr('item-url'));
	});
});

//添加插件扩展
(function(p){
	p = window.plus;
	var b = p.bridge,plus = 'ypzan';
	p.ypzan = {
		notice:function(msg, callback, option){
			option	= option || {};
			var callbackID = b.callbackId(callback),
				options	= {
					msg : msg, 
					pos : option.pos || 'center',
					font : option.font || '_www/fonts/iconfont.ttf',
					iconSize : option.iconSize || 30,
					fontSize : option.fontSize || 16,
					autoHide : option.autoHide || 2000,
				};
				option.icon && (options.icon = option.icon);
				
			return b.exec(plus, 'notice', [callbackID, options]);
		},
		alert : function(title, msg, button, callback){
			var callbackID = b.callbackId(callback);
			return b.exec(plus, 'alert', [callbackID, title || '系统提示', msg || '', [button || '确认']]);
		},
		confirm : function(title, msg, buttons, callback){
			var callbackID = b.callbackId(callback);
			return b.exec(plus, 'alert', [callbackID, title || '系统提示', msg || '', buttons]);
		},
		setClipboard : function(value){
			return b.exec(plus, "clipboard", [1, value]);
		},
		getClipboard : function(){
			return b.execSync(plus, "clipboard", [0]);
		},
		cache : {
			size : function(callback){
				var callbackID = b.callbackId(callback);
				if(Tools.os.android){
					return b.exec(plus, 'cache', [callbackID, 0]);
				}else{
					return b.exec('Cache',"calculate",[callbackID]);
				}
			},
			clear : function(callback){
				var callbackID = b.callbackId(callback);
				if(Tools.os.android){
					return b.exec(plus, 'cache', [callbackID, 1]);
				}else{
					return b.exec('Cache',"clear",[callbackID]);
				}
			}
		},
		/**
		 * type:分享类型不传则表示一键分享，传递需要传递平台类型：
		 * 平台类型：QQ:10  Q空间:11   微信好友:12  微信朋友圈：13  新浪微博：14  腾讯微博：15  短信：16
		 */
		share : function(title, content, url, image, callback, hide, type){
			var callbackID = b.callbackId(callback), param = [];
			image = $.isArray(image) ? image[0] : image;
			param.push(type ? 1 : 0);
			if(type){
				param.push(type);
			}
			var share = {
				hiddenPlatform : hide,
				title : title,
				content : content,
				url : url,
				appName : '亿品赞'
			};
			if(image.substr(0, 4) == 'http'){
				share.imageUrl = image;
			}else{
				share.imagePath = image;
			}
			
			param.push(share);
			
			return b.exec(plus, 'thirdParty', [callbackID, 0, param]);
		},
		login : function(type, callback){
			var callbackID = b.callbackId(callback);
			return b.exec(plus, 'thirdParty', [callbackID, 1, type]);
		},
		//type ： 平台类型
		isInstall : function(type, callback){
			var callbackID = b.callbackId(callback);
			!$.isArray(type) && (type = [type]);
			return b.exec(plus, 'thirdParty', [callbackID, 2, type]);
		},
		update:function(url){
			return b.exec(plus, 'update', [url]);
		},
		sign : function(data){
			return b.execSync(plus, "sign", [data]);
		},
		miniProgram : function(userName, url, imageUrl, title, content, open, callback){
			var callbackID = b.callbackId(callback);
			return b.exec(plus, "thirdParty", [callbackID, 3, {
				userName : userName,
				url : url,
				title : title ||  '',
				content : content || '',
				imageUrl : imageUrl || '',
				open : !!open,
				type : 2
			}]);
		}
	};
})(window.plus);